// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.Any;

public interface AnyDictionary extends Any {

	// accessing
	public AnyArray keys();
	public AnyArray values();
	public int size();
	public int fullSize();


	// accessing slots
	public Any at(AnyString key);
	public Any at(String key);
	public Any at(AnyString key, int pos);
	public Any at(String key, int pos);
	public Any slotAt(AnyString key);
	public Any slotAt(String key);
	public AnyArray arrayAt(AnyString key);
	public AnyArray arrayAt(String key);
	public int sizeAt(AnyString key);
	public int sizeAt(String key);
		
	// manipulating slots
	public void append(AnyString key, Any newElement);
	public void append(String key, Any newElement);
	public void appendArray(AnyString key, AnyArray newElements);
	public void appendArray(String key, AnyArray newElements);
	public void atPut(AnyString key, Any newElement);
	public void atPut(String key, Any newElement);
	public void atPut(AnyString key, int pos, Any newElement);
	public void atPut(String key, int pos, Any newElement);
	public void setSlot(AnyString key, Any value);
	public void setSlot(String key, Any value);
	public Any remove(AnyString key);
	public Any remove(String key);
	public Any remove(AnyString key, int pos);
	public Any remove(String key, int pos);
	public AnyArray removeSlot(AnyString key);
	public AnyArray removeSlot(String key);

	// testing
	public boolean hasSlot(AnyString key);
	public boolean hasSlot(String key);

}
