// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.Any;

public interface AnyFrameDescriptor extends Any {

	// accessing
	public AnyDictionary getContents();
	public AnyContext getContext();
	public AnyString getDescription();
	public AnyString getName();
	public AnyFrameDescriptor getSuperFrameDescriptor();
	public int numberOfSlots();
	public int totalNumberOfSlots();
	public AnyArray slotNames();
	public AnyArray allSlotNames();

	
	// setting
	public void setContents(AnyDictionary anAnyDictionary);
	public void setDescription(AnyString description);
	public void setDescription(String description);
	public void setName(AnyString anAnyString);
	public void setName(String anAnyString);
	public void setSuperFrameDescriptor(AnyFrameDescriptor anAnyFrameDescriptor);
	
	// accessing slots
	public AnySlotDescriptor at(AnyString key);
	public AnySlotDescriptor at(String key);
	public int offset(AnyString key);	
	
	// manipulations slots
	public void append(AnyString key, AnySlotDescriptor desc);
	public void append(String key, AnySlotDescriptor desc);
	public AnySlotDescriptor remove(AnyString key);
	public AnySlotDescriptor remove(String key);

	// misc
	public AnyFrame convertToFrame();

}
