// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.AnyFormatter;



public class AnyFormatterImpl implements AnyFormatter {

	// instance variables
	
	protected String indentationString;
	protected int depth;
	protected boolean doIndent;


	// constructors
	
	public AnyFormatterImpl() { 
		this("   ");
	}
	
	public AnyFormatterImpl(String indentationString) {
		depth = 0;
		doIndent = true;
		this.indentationString = indentationString;
	}
	
	
	// accessing

	public String getIndentation() {
		StringBuffer buffer = new StringBuffer();
		if (doIndent) {
			buffer.append('\n');
			for (int i=0; i<depth; i++) 
				buffer.append(indentationString); }
		else
			buffer.append(' ');
		return buffer.toString();
	}	
	
	
	// setting
	
	public void setDoIndent() {
		doIndent = true;
	}
	
	public void setNoIndent() {
		doIndent = false;
	}
	
	public void setIndentationString(String indentString) {
		indentationString = indentString;
	}


	// formatting

	public void increment() {
		depth++;
	}
	
	public void decrement() {
		depth--;
	}

}
